<template>
    <div class="w-screen h-screen bg-dark text-white px-4 overflow-y-scroll fixed">
        <div
            class="mx-auto text-center py-6 cursor-pointer"
            @click="$router.push({name: 'user.auth.login'})"
        >
            <img
                :src="'/img/logo.png'"
                class="h-24 mx-auto text-center"
            >
        </div>
        <div
            class="text-center font-bold capitalize text-2xl"
        >
            {{ $t('reset_password') }}
        </div>
        <div
            class="text-center text-gray-400 text-xs mb-12"
        >
            {{ $t('please_provide_your_registered_email_to_obtain_reset_password_link') }}
        </div>
        <div
            class="py-2"
        >
            <auto-form
                ref="form"
                :fields="fields"
                :dark="true"
                :hidden-data="{
                    token: $route.params.token
                }"
                size="lg"
                @form-update="onFormUpdate"
            />
            <div
                class="my-12"
            >
                <auto-button
                    class="text-2xl tracking-wider"
                    :busy="form && form.busy ? form.busy : false"
                    :disabled="form && form.busy ? form.busy : false"
                    @click="submitForm"
                >
                    {{ $t('reset') }}
                </auto-button>
            </div>
        </div>
    </div>
</template>

<script setup>
import {computed, inject, ref} from "vue";
import {useRouter} from 'vue-router';
import AutoForm from '~/components/auto-form.vue';
import {useI18n} from "vue-i18n";
import AutoButton from "~/components/button/auto-button.vue";

const $router = useRouter();
const $helper = inject('$helper');

const {t} = useI18n();
const step = ref(1);
const form = ref();
const cloneEmail = ref('');
const fields = [
    {type: 'email', name: 'email', label: t('email'), placeholder: 'abc@ask.com', dark: true, size: 'lg'},
    {type: 'text', name: 'username', label: t('username'), placeholder: 'abc1234', dark: true, size: 'lg'},
    {type: 'password', name: 'password', label: t('new_password'), dark: true, size: 'lg'},
    {type: 'password', name: 'password_confirmation', label: t('new_password_confirmation'), dark: true, size: 'lg'},
    {type: 'pin', name: 'password2', label: t('new_password2'), dark: true, size: 'lg'},
    {type: 'pin', name: 'password2_confirmation', label: t('new_password2_confirmation'), dark: true, size: 'lg'},
];

const submitForm = async () => {
    try {
        const resp = await form.value.submitForm('/reset_password');
        await $helper.alertSuccess({
            message: resp.message,
            callback: async () => {
                await $router.push({name: 'user.auth.login'});
            }
        });
    } catch (e) {
        console.log(e);
    }
}

const onFormUpdate = (fd) => {
    if (fd.get('email')) {
        cloneEmail.value = fd.get('email');
    }
};
</script>
